unit U_PBCKOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxGridCustomTableView,
  cxGridTableView, cxGridBandedTableView, cxGridDBBandedTableView,
  cxGridLevel, cxClasses, cxControls, cxGridCustomView, cxGridDBTableView,
  cxGrid, StdCtrls, ComCtrls, ExtCtrls, ToolWin, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxDropDownEdit, cxCheckBox, RM_Common,
  RM_Class, RM_e_Xls, RM_Dataset, RM_System, RM_GridReport, Menus,
  cxCalendar;

type
  TfrmPBCKOutList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column1: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBRKCX: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    v1Column5: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Label3: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    BatchNO: TEdit;
    v1Column9: TcxGridDBColumn;
    Label6: TLabel;
    SPCF: TEdit;
    Label7: TLabel;
    SPMF: TEdit;
    v1Column11: TcxGridDBColumn;
    Label9: TLabel;
    SPKZ: TEdit;
    Label10: TLabel;
    ShaZhi: TEdit;
    Label11: TLabel;
    SPType: TComboBox;
    Label5: TLabel;
    OrderNo: TEdit;
    v1Column4: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    Label12: TLabel;
    FromFactoryName: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBRKCXClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure BatchNOChange(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure OrderNoKeyPress(Sender: TObject; var Key: Char);
  private
    procedure InitGrid();
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPBCKOutList: TfrmPBCKOutList;

implementation
uses
  U_DataLink,U_RTFun,U_PBCKInPut;

{$R *.dfm}

procedure TfrmPBCKOutList.FormDestroy(Sender: TObject);
begin
  frmPBCKOutList:=nil;
end;

procedure TfrmPBCKOutList.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmPBCKOutList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  EndDate.DateTime:=SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime:=EndDate.DateTime;
end;

procedure TfrmPBCKOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      sql.Clear;
      sql.Add(' select AA.* from(');
      sql.Add(' select A.*,MDQty=MD.Qty,MDPS=MD.PS,MD.MDNO,MD.MDDate,MD.FromFactoryName ');
      sql.Add(' ,orderNo=(select OrderNo from JYOrder_Main JM where JM.MainId=MD.ORDMainId)');
      sql.Add(' from JYOrder_Main_MD MD');
      sql.Add(' inner join CK_SXPB_KC A on MD.BatchNo=A.BatchNo');
      sql.add('where MD.MDDate>=:begdate and MD.MDDate<:enddate and isnull(A.CKName,'''')=''坯布'' ');
      sql.Add(' and isnull(MD.CKName,'''')='''' ) AA');
      Parameters.ParamByName('begdate').Value:=Trim(FormatDateTime('yyyy-MM-dd',BegDate.DateTime));
      Parameters.ParamByName('enddate').Value:=Trim(FormatDateTime('yyyy-MM-dd',enddate.DateTime+1));
      Open;
      //ShowMessage(SQL.Text);
    end;
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmPBCKOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmPBCKOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  end;
end;

procedure TfrmPBCKOutList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('坯布出库列表',Tv1,'坯布仓库');
  Close;
end;

procedure TfrmPBCKOutList.FormShow(Sender: TObject);
begin
  ReadCxGrid('坯布出库列表',Tv1,'坯布仓库');
  //InitGrid();
end;

procedure TfrmPBCKOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then exit;
  TcxGridToExcel('坯布出库列表',cxGrid2);
end;

procedure TfrmPBCKOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  end;
end;

procedure TfrmPBCKOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main,True);
end;

procedure TfrmPBCKOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main,False);
end;

procedure TfrmPBCKOutList.TBRKCXClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString)<>'' then
  begin
    if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID='''+Trim(CDS_Main.fieldbyname('SPID').AsString)+'''');
        sql.Add('Update CK_SXPB_KC Set KCKGQty=(select sum(isnull(KGQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(',KCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(' where CRID='+Trim(CDS_Main.fieldbyname('CRID').AsString));
        ExecSQL;
      end;
      with ADOQueryTemp do
      begin
        Close;
        sql.Clear;
        sql.Add('select * from CK_SXPB_KC where CRID='+Trim(CDS_Main.fieldbyname('CRID').AsString));
        Open;
      end;
      if ADOQueryTemp.FieldByName('KCKGQty').Value<0 then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('入库公斤数小于出库公斤数不能删除!','提示',0);
        Exit;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!','提示',0);
    end;

  end else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmPBCKOutList.ToolButton1Click(Sender: TObject);
begin
  try
    frmPBCKInPut:=TfrmPBCKInPut.Create(Application);
    with frmPBCKInPut do
    begin
      FBCId:='';
      if ShowModal=1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmPBCKInPut.Free;
  end;
end;

procedure TfrmPBCKOutList.ToolButton2Click(Sender: TObject);
begin
  try
    frmPBCKInPut:=TfrmPBCKInPut.Create(Application);
    with frmPBCKInPut do
    begin
      FBCId:=Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible:=False;
      TBAdd.Visible:=False;
      if ShowModal=1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmPBCKInPut.Free;
  end;
end;

procedure TfrmPBCKOutList.BatchNOChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmPBCKOutList.FactoryNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmPBCKOutList.OrderNoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
  begin
    if Length(Trim(OrderNo.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select AA.* from(');
        sql.Add(' select A.*,MDQty=MD.Qty,MDPS=MD.PS,MD.MDNO ');
        sql.Add(' ,orderNo=(select OrderNo from JYOrder_Main JM where JM.MainId=MD.ORDMainId)');
        sql.Add(' from JYOrder_Main_MD MD');
        sql.Add(' inner join CK_SXPB_KC A on MD.BatchNo=A.BatchNo');
        sql.add(' where   isnull(A.CKName,'''')=''坯布'' ');
        sql.Add(' and isnull(MD.CKName,'''')='''' ) AA');
        sql.Add(' where OrderNo like '''+'%'+Trim(OrderNo.Text)+'%'+'''');
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;
end;

end.
